// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_multi_robot_msgs:msg/RobotGoals.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__STRUCT_H_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'robot_name'
#include "rosidl_runtime_c/string.h"
// Member 'destinations'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in msg/RobotGoals in the package tuw_multi_robot_msgs.
/**
  * used to describe a set of destinations for a robot
  * robot_name is used as id and often used as namespace for topics
 */
typedef struct tuw_multi_robot_msgs__msg__RobotGoals
{
  /// the name of the robot
  rosidl_runtime_c__String robot_name;
  /// Describes a set of destinations, where the last one is the final goal of the trip
  /// if there are more than one destinations the first one is the start pose
  /// else the current pose of the robot is used as start
  geometry_msgs__msg__Pose__Sequence destinations;
} tuw_multi_robot_msgs__msg__RobotGoals;

// Struct for a sequence of tuw_multi_robot_msgs__msg__RobotGoals.
typedef struct tuw_multi_robot_msgs__msg__RobotGoals__Sequence
{
  tuw_multi_robot_msgs__msg__RobotGoals * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__msg__RobotGoals__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__STRUCT_H_
