// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/RouterStatus.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__RouterStatus __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__RouterStatus __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RouterStatus_
{
  using Type = RouterStatus_<ContainerAllocator>;

  explicit RouterStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->success = false;
      this->duration = 0l;
      this->overall_path_length = 0l;
      this->longest_path_length = 0l;
      this->priority_scheduling_attemps = 0l;
      this->speed_scheduling_attemps = 0l;
    }
  }

  explicit RouterStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->success = false;
      this->duration = 0l;
      this->overall_path_length = 0l;
      this->longest_path_length = 0l;
      this->priority_scheduling_attemps = 0l;
      this->speed_scheduling_attemps = 0l;
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _success_type =
    bool;
  _success_type success;
  using _missing_robots_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _missing_robots_type missing_robots;
  using _duration_type =
    int32_t;
  _duration_type duration;
  using _overall_path_length_type =
    int32_t;
  _overall_path_length_type overall_path_length;
  using _longest_path_length_type =
    int32_t;
  _longest_path_length_type longest_path_length;
  using _priority_scheduling_attemps_type =
    int32_t;
  _priority_scheduling_attemps_type priority_scheduling_attemps;
  using _speed_scheduling_attemps_type =
    int32_t;
  _speed_scheduling_attemps_type speed_scheduling_attemps;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__missing_robots(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->missing_robots = _arg;
    return *this;
  }
  Type & set__duration(
    const int32_t & _arg)
  {
    this->duration = _arg;
    return *this;
  }
  Type & set__overall_path_length(
    const int32_t & _arg)
  {
    this->overall_path_length = _arg;
    return *this;
  }
  Type & set__longest_path_length(
    const int32_t & _arg)
  {
    this->longest_path_length = _arg;
    return *this;
  }
  Type & set__priority_scheduling_attemps(
    const int32_t & _arg)
  {
    this->priority_scheduling_attemps = _arg;
    return *this;
  }
  Type & set__speed_scheduling_attemps(
    const int32_t & _arg)
  {
    this->speed_scheduling_attemps = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RouterStatus
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RouterStatus
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouterStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RouterStatus_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    if (this->missing_robots != other.missing_robots) {
      return false;
    }
    if (this->duration != other.duration) {
      return false;
    }
    if (this->overall_path_length != other.overall_path_length) {
      return false;
    }
    if (this->longest_path_length != other.longest_path_length) {
      return false;
    }
    if (this->priority_scheduling_attemps != other.priority_scheduling_attemps) {
      return false;
    }
    if (this->speed_scheduling_attemps != other.speed_scheduling_attemps) {
      return false;
    }
    return true;
  }
  bool operator!=(const RouterStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RouterStatus_

// alias to use template instance with default allocator
using RouterStatus =
  tuw_multi_robot_msgs::msg::RouterStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTER_STATUS__STRUCT_HPP_
